"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.clientHandler = clientHandler;
exports.openAndroidBrowser = openAndroidBrowser;
exports.closeAndroidBrowser = closeAndroidBrowser;
exports.ID = void 0;

var _adb = _interopRequireDefault(require("./adb"));

var _taiko = require("taiko");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let adb;
let taikoSession;
let page;
let tcpProp;
process.env['LOCAL_PROTOCOL'] = true;
const ID = 'android';
exports.ID = ID;

async function clientHandler(taiko) {
  taikoSession = await taiko.client();
  page = await taiko.client().Page;
  Promise.all([page.enable()]);
}

async function openAndroidBrowser() {
  adb = new _adb.default();
  await adb.checkIfDevices();
  let tcpDetails = await adb.portForwardTcp();
  tcpProp = Object.assign({}, ...tcpDetails.map(tcp => ({
    tcp
  })));
  const device = tcpProp.tcp.device;
  await adb.closeChrome(device);
  await adb.skipChromeWelcomeScreen(device);
  await adb.openChrome(device);
  await adb.currentActivity(device);
  await (0, _taiko.openBrowser)(tcpProp.tcp);
  return {
    description: 'Browser opened'
  };
}

async function closeAndroidBrowser() {
  await page.close();
  await taikoSession.removeAllListeners();
  await taikoSession.close();
  await adb.closeChrome(tcpProp.tcp.device);
}